/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#ifndef P_1_H
#define P_1_H

#include "math.h"
#include "yapi.h"

#include "aux_func.h"
#include <iostream>


class P_1 : public Process {
  private:

    // Input Gates and controllers

    // Output Gates
    OutPort<tCH_1> OG_1;

    // Parameters

    // Input Arguments 

    // Output Arguments 
    tCH_1 out_0ND_0;

  public:

    // Constructor 
    P_1(Id n,
    Out<tCH_1>& OG_1_instance) :
    Process(n),
    OG_1(id("OG_1"), OG_1_instance )
    {
    }; 

    const char* type() const {return "P_1";};

    void main() {

      for( int c0 =  ceil1(0); c0 <=  floor1(31 ); c0 += 1 ) {
        for( int c1 =  ceil1(1); c1 <=  floor1(1 ); c1 += 1 ) {
          for( int c2 =  ceil1(1); c2 <=  floor1(1 ); c2 += 1 ) {

              _initVideoIn(out_0ND_0) ;
              execute("_initVideoIn");


              write( OG_1, out_0ND_0);

          } // for c2
        } // for c1
      } // for c0

    } // main
};

#endif
