/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#ifndef P_12_H
#define P_12_H

#include "math.h"
#include "yapi.h"

#include "aux_func.h"
#include <iostream>


class P_12 : public Process {
  private:

    // Input Gates and controllers
    InPort<tCH_1> IG_1;
    InPort<tCH_14> IG_2;

    // Output Gates

    // Parameters

    // Input Arguments 
    tCH_1 in_0ND_11;
    tCH_14 in_1ND_11;

    // Output Arguments 

  public:

    // Constructor 
    P_12(Id n,
    In<tCH_1>& IG_1_instance,
    In<tCH_14>& IG_2_instance) :
    Process(n),
    IG_1(id("IG_1"), IG_1_instance ),
    IG_2(id("IG_2"), IG_2_instance )
    {
    }; 

    const char* type() const {return "P_12";};

    void main() {

      for( int c0 =  ceil1(0); c0 <=  floor1(31 ); c0 += 1 ) {
        for( int c1 =  ceil1(1); c1 <=  floor1(16 ); c1 += 1 ) {
          for( int c2 =  ceil1(1); c2 <=  floor1(8 ); c2 += 1 ) {
              if( c1-1 == 0 ) {
                if( c2-1 == 0 ) {
                  read(IG_1, in_0ND_11);

                }
              }
              read(IG_2, in_1ND_11);


              _mainVideoOut(in_0ND_11, in_1ND_11) ;
              execute("_mainVideoOut");

          } // for c2
        } // for c1
      } // for c0

    } // main
};

#endif
