/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#ifndef P_2_H
#define P_2_H

#include "math.h"
#include "yapi.h"

#include "aux_func.h"
#include <iostream>


class P_2 : public Process {
  private:

    // Input Gates and controllers

    // Output Gates
    OutPort<tCH_2> OG_1;
    OutPort<tCH_4> OG_2;
    OutPort<tCH_6> OG_3;
    OutPort<tCH_8> OG_4;

    // Parameters

    // Input Arguments 

    // Output Arguments 
    tCH_8 out_0ND_1;

  public:

    // Constructor 
    P_2(Id n,
    Out<tCH_2>& OG_1_instance,
    Out<tCH_4>& OG_2_instance,
    Out<tCH_6>& OG_3_instance,
    Out<tCH_8>& OG_4_instance) :
    Process(n),
    OG_1(id("OG_1"), OG_1_instance ),
    OG_2(id("OG_2"), OG_2_instance ),
    OG_3(id("OG_3"), OG_3_instance ),
    OG_4(id("OG_4"), OG_4_instance )
    {
    }; 

    const char* type() const {return "P_2";};

    void main() {

      for( int c0 =  ceil1(0); c0 <=  floor1(31 ); c0 += 1 ) {
        for( int c1 =  ceil1(1); c1 <=  floor1(16 ); c1 += 1 ) {
          for( int c2 =  ceil1(1); c2 <=  floor1(8 ); c2 += 1 ) {

              _mainVideoIn(out_0ND_1) ;
              execute("_mainVideoIn");

              if( -c2 + 2 >= 0 ) {

                write( OG_1, out_0ND_1);

              }
              if( c2-3 >= 0 ) {
                if( -c2 + 4 >= 0 ) {

                  write( OG_2, out_0ND_1);

                }
              }
              if( c2-5 >= 0 ) {
                if( -c2 + 6 >= 0 ) {

                  write( OG_3, out_0ND_1);

                }
              }
              if( c2-7 >= 0 ) {

                write( OG_4, out_0ND_1);

              }
          } // for c2
        } // for c1
      } // for c0

    } // main
};

#endif
