/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#ifndef P_7_H
#define P_7_H

#include "math.h"
#include "yapi.h"

#include "aux_func.h"
#include <iostream>


class P_7 : public Process {
  private:

    // Input Gates and controllers
    InPort<tCH_6> IG_1;

    // Output Gates
    OutPort<tCH_7> OG_1;

    // Parameters

    // Input Arguments 
    tCH_6 in_0ND_6;

    // Output Arguments 
    tCH_7 out_1ND_6;

  public:

    // Constructor 
    P_7(Id n,
    In<tCH_6>& IG_1_instance,
    Out<tCH_7>& OG_1_instance) :
    Process(n),
    IG_1(id("IG_1"), IG_1_instance ),
    OG_1(id("OG_1"), OG_1_instance )
    {
    }; 

    const char* type() const {return "P_7";};

    void main() {

      for( int c0 =  ceil1(0); c0 <=  floor1(31 ); c0 += 1 ) {
        for( int c1 =  ceil1(1); c1 <=  floor1(16 ); c1 += 1 ) {
          for( int c2 =  ceil1(5); c2 <=  floor1(6 ); c2 += 1 ) {
              read(IG_1, in_0ND_6);


              _mainDCT(in_0ND_6, out_1ND_6) ;
              execute("_mainDCT");


              write( OG_1, out_1ND_6);

          } // for c2
        } // for c1
      } // for c0

    } // main
};

#endif
