/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#ifndef aux_func_H
#define aux_func_H

#include <math.h>
#include "mjpeg_func.h"

typedef struct THeaderInfo tCH_1;
typedef struct TBlocks tCH_2;
typedef struct TBlocks tCH_3;
typedef struct TBlocks tCH_4;
typedef struct TBlocks tCH_5;
typedef struct TBlocks tCH_6;
typedef struct TBlocks tCH_7;
typedef struct TBlocks tCH_8;
typedef struct TBlocks tCH_9;
typedef struct TBlocks tCH_10;
typedef struct TBlocks tCH_11;
typedef struct TBlocks tCH_12;
typedef struct TBlocks tCH_13;
typedef struct TPackets tCH_14;

inline
void  _initVideoIn( tCH_1 &out_0 ) {
    initVideoIn( &out_0 );
}

inline
void  _mainVideoIn( tCH_8 &out_0 ) {
    mainVideoIn( &out_0 );
}

inline
void  _mainDCT( tCH_2 in_0, tCH_3 &out_1 ) {
    mainDCT( &in_0, &out_1 );
}

inline
void  _mainQ( tCH_3 in_0, tCH_10 &out_1 ) {
    mainQ( &in_0, &out_1 );
}

inline
void  _mainVLE( tCH_13 in_0, tCH_14 &out_1 ) {
    mainVLE( &in_0, &out_1 );
}

inline
void  _mainVideoOut( tCH_1 in_0, tCH_14 in_1 ) {
    mainVideoOut( &in_0, &in_1 );
}


inline
double min( double a, double b ){
  if ( a>=b )  {
    return b;
  } else {
    return a;
  }
}

inline
double max( double a, double b ){
  if ( a>=b )  {
    return a;
  } else {
    return b;
  }
}

inline
int ddiv( double a, double b ){

    //return (int)(a/b);
    return ( (int) (((a)<0) ? ((a)-(b)+1)/(b) : (a)/(b)) ); 
    //return ( (int) (((a)<0)^((b)<0) ? ((a) < 0 ? ((a)-(b)+1)/(b) : ((a)-(b)-1)/(b)) : (a)/(b)) ); 
}

inline
int mod( double a, double b ){

    return (int)fmod(a, b);
}

inline
int ceil1( double a ){

    return (int) ceil(a);
}

inline
int floor1( double a ){

    return (int) floor(a);
}


#endif
