/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

// File automatically generated by ESPAM
#ifndef mjpeg_KPN_H
#define mjpeg_KPN_H

#include "yapi.h"

#include "P_1.h"
#include "P_2.h"
#include "P_3.h"
#include "P_4.h"
#include "P_5.h"
#include "P_6.h"
#include "P_7.h"
#include "P_8.h"
#include "P_9.h"
#include "P_10.h"
#include "P_11.h"
#include "P_12.h"

class mjpeg : public ProcessNetwork {
  private:
    // Channels
    Fifo<tCH_1> CH_1;
    Fifo<tCH_2> CH_2;
    Fifo<tCH_3> CH_3;
    Fifo<tCH_4> CH_4;
    Fifo<tCH_5> CH_5;
    Fifo<tCH_6> CH_6;
    Fifo<tCH_7> CH_7;
    Fifo<tCH_8> CH_8;
    Fifo<tCH_9> CH_9;
    Fifo<tCH_10> CH_10;
    Fifo<tCH_11> CH_11;
    Fifo<tCH_12> CH_12;
    Fifo<tCH_13> CH_13;
    Fifo<tCH_14> CH_14;

    // processes
    P_1 P_1_instance;
    P_2 P_2_instance;
    P_3 P_3_instance;
    P_4 P_4_instance;
    P_5 P_5_instance;
    P_6 P_6_instance;
    P_7 P_7_instance;
    P_8 P_8_instance;
    P_9 P_9_instance;
    P_10 P_10_instance;
    P_11 P_11_instance;
    P_12 P_12_instance;

 public: 
  mjpeg(
    Id n
  ) :
    ProcessNetwork(n),
    CH_1(id("CH_1"),1,1),
    CH_2(id("CH_2"),1,1),
    CH_3(id("CH_3"),1,1),
    CH_4(id("CH_4"),1,1),
    CH_5(id("CH_5"),1,1),
    CH_6(id("CH_6"),1,1),
    CH_7(id("CH_7"),1,1),
    CH_8(id("CH_8"),1,1),
    CH_9(id("CH_9"),1,1),
    CH_10(id("CH_10"),1,1),
    CH_11(id("CH_11"),1,1),
    CH_12(id("CH_12"),1,1),
    CH_13(id("CH_13"),1,1),
    CH_14(id("CH_14"),1,1),
    P_1_instance(id("P_1"), CH_1),
    P_2_instance(id("P_2"), CH_2, CH_4, CH_6, CH_8),
    P_3_instance(id("P_3"), CH_2, CH_3),
    P_4_instance(id("P_4"), CH_3, CH_10),
    P_5_instance(id("P_5"), CH_4, CH_5),
    P_6_instance(id("P_6"), CH_5, CH_11),
    P_7_instance(id("P_7"), CH_6, CH_7),
    P_8_instance(id("P_8"), CH_7, CH_12),
    P_9_instance(id("P_9"), CH_8, CH_9),
    P_10_instance(id("P_10"), CH_9, CH_13),
    P_11_instance(id("P_11"), CH_10, CH_11, CH_12, CH_13, CH_14),
    P_12_instance(id("P_12"), CH_1, CH_14)
    {
    };

  const char* type() const { return "mjpeg"; };

};

#endif /* mjpeg_H */
