/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

/*
***********************************************************
param.h

The basic system parameters of M_JPEG* are kept here.

***********************************************************
*/

#ifndef PARAM_DONE
#define PARAM_DONE

/*
 This is the general definition for the size and width of the
 M_JPEG* blocks.
*/
#define BLOCKSIZE  64
#define BLOCKWIDTH  8
#define BLOCKHEIGHT 8
#define PACKETSIZE  1    // The size of the packet in bits is 8*PACKETSIZE

// This is the minimum compression ratio the M_JPEG* application should support
#define THRESHOLD 100

// Q value is used to rescale quantization matrices.
#define Q_PRECISION 50

// Definitions for M_JPEG* and internal compatibility.
#define MAXIMUM_MJPEG_HORIZONTAL_FREQUENCY 4
#define MAXIMUM_MJPEG_VERTICAL_FREQUENCY 4
#define MAXIMUM_IMAGE_HEIGHT 65535
#define MAXIMUM_IMAGE_WIDTH 65535

/*
 Components: Number of color components that can be active per frame.
 A component consists of one complete plane of the image.
*/
#define MAXIMUM_COMPONENTS 256

/*
 Scan component threshold is the maximum number of color components put
 in per scan
*/
#define SCAN_COMPONENT_THRESHOLD 4

/*
 Number of streams is the number of active read/write streams possible.
 For all M_JPEG* operations, this value is 1.
*/
#define NUMBER_OF_STREAMS 1

#endif

